/* ¹Υƥѥ */
#if 0		/* Patched by G-HAL */
#include <stdio.h>
#include <anthy/dic.h>
#include <anthy/diclib.h>
#include <anthy/matrix.h>
#else
#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_STDLIB_H)
# include <stdlib.h>
#endif
#if defined(HAVE_STDIO_H)
# include <stdio.h>
#endif
#if defined(HAVE_ARPA_INET_H)
# include <arpa/inet.h>
#endif
#if defined(HAVE_SYS_TYPES_H)
# include <sys/types.h>
#endif
#if defined(HAVE_NETINET_IN_H)
# include <netinet/in.h>
#endif

#include "anthy/dic.h"
#include "anthy/diclib.h"
#include "anthy/matrix.h"
#endif

#if 0	/* Patched by G-HAL, Sat,17 Sep,2011 */
static void
change_endian(struct matrix_image *im)
{
  int i;
  for (i = 0; i < im->size; i++) {
    im->image[i] = anthy_dic_htonl(im->image[i]);
  }
}
#else
inline static void change_endian( struct matrix_image* const im )
{
  size_t i;
  for (i = 0; i < im->size; ++i) {
    im->image[i] = htonl( im->image[i] );
  }
  return;
}
#endif

static void
zero_matrix(void)
{
  struct sparse_matrix *m;
  struct matrix_image *mi;
  int *im, e;
  m = anthy_sparse_matrix_new();
  anthy_sparse_matrix_make_matrix(m);
  mi = anthy_matrix_image_new(m);
  change_endian(mi);
  im = mi->image;
  e = anthy_matrix_image_peek(im, 0, 0);
  printf("zero matrix: size=%d (0,0)=%d\n", mi->size, e);
}

static void
dense_matrix(void)
{
  int i, j, fail;
  struct sparse_matrix *m;
  struct matrix_image *mi;
  int *im, e;
  m = anthy_sparse_matrix_new();
  for (i = 0; i < 100; i++) {
    for (j = 0; j < 100; j++) {
      anthy_sparse_matrix_set(m, i, j, i + j, NULL);
    }
  }
  anthy_sparse_matrix_make_matrix(m);
  mi = anthy_matrix_image_new(m);
  change_endian(mi);
  im = mi->image;
  fail = 0;
  for (i = 0; i < 100; i++) {
    for (j = 0; j < 100; j++) {
      e = anthy_matrix_image_peek(im, i, j);
      if (e != i+j) {
	printf("image(%d,%d) == %d != %d\n", i,j,e,i+j);
	fail ++;
      }
      e = anthy_sparse_matrix_get_int(m, i, j);
      if (e != i+j) {
	printf("origin(%d,%d) == %d != %d\n", i,j,e,i+j);
	fail ++;
      }
    }
  }
  printf("%d errors in desnse matrix\n", fail);
}

int
main(_unused int argc, _unused char **argv)
{
  zero_matrix();
  dense_matrix();
  return 0;
}
/* vim:ts=8 sw=2 nomodified:
 */
